setlocal textwidth=0
setlocal nospell
" setlocal spelllang=en
setlocal nofoldenable
setlocal formatoptions+=pq

function OrgFold(lnum)
  let level = strlen(matchstr(getline(a:lnum), '\v^\s*\zs\*+'))
  if level > 0
    return '>'.level
  else
    return '='
  endif
endfunction

setlocal foldmethod=expr foldexpr=OrgFold(v:lnum)
setlocal foldtext=getline(v:foldstart).'...'.repeat('\ ',999)

let b:match_words = '^\#+BEGIN.\+$:^\#+END.\+$'

function! SelectCodeBlock(inner) abort
  call search('^#+BEGIN.\+', 'bcW')
  execute 'normal ' . (a:inner ==# 'i' ? 'jv' : 'v')
  call search('^#+END.\+$', 'cW')
  execute 'normal ' . (a:inner ==# 'i' ? 'k$' : '$')
endfunction

xnoremap <silent> ac :<C-u>call SelectCodeBlock("a")<CR>
onoremap <silent> ac :<C-u>normal vac<CR>
xnoremap <silent> ic :<C-u>call SelectCodeBlock("i")<CR>
onoremap <silent> ic :<C-u>normal vic<CR>

iabbrev <buffer> =q #+BEGIN_QUOTE<CR>#+END_QUOTE<Esc>2k$
iabbrev <buffer> =e #+BEGIN_EXAMPLE<CR>#+END_EXAMPLE<Esc>2k$
iabbrev <buffer> =c #+CAPTION: xxx<CR>#+LABEL: xxx<CR>#+NAME: xxx<CR><Esc>0
iabbrev <buffer> =w [[][]]<Esc>5h
iabbrev <buffer> =" #+BEGIN_SRC<CR>#+END_SRC<Esc>2k
iabbrev <buffer> =' ==<Esc>2h
iabbrev <buffer> =E \begin{equation*}<CR>\end{equation*}<Esc>2k
iabbrev <buffer> =A \begin{aligned}<CR>\end{aligned}<Esc>2k

nmap <buffer> gs :10 split term://org-babel -pdf % && zathura %:r.pdf<cr>:startinsert<cr>

nnoremap <silent> gr :call fzf#run({
                        \ 'source': 'bibtex-ls',
                        \ 'sink*': function('bibtex#bibtex_cite_tex_sink'),
                        \ 'down': '10%',
                        \ 'options': '--ansi --multi --border top --prompt "Cite> "'})<CR>

inoremap <silent> <C-h> <c-g>u<c-o>:call fzf#run({
                        \ 'source': bibtex#bibtex_ls_in(),
                        \ 'sink*': function('bibtex#bibtex_cite_sink_insert'),
                        \ 'down': '10%',
                        \ 'options': '--ansi --multi --border top --prompt "Cite> "'})<CR>
