setlocal autoindent expandtab tabstop=2 shiftwidth=2

iabbrev <buffer> =c \begin{chapter}
iabbrev <buffer> =s \begin{section}
iabbrev <buffer> =p \paragraph{TITLE}<Esc>?TITLE<CR>cw
iabbrev <buffer> =i \begin{itemize}<CR>
iabbrev <buffer> =e \begin{enumerate}<CR>
iabbrev <buffer> =E \begin{equation}<CR>
iabbrev <buffer> =t \begin{tabular}{ALG}<CR><Esc>?ALG<CR>cw
iabbrev <buffer> =T \begin{table}[POS]<CR>\centering<CR>\caption{}<CR>\label{}<CR><Esc>?POS<CR>cw
iabbrev <buffer> =f \begin{figure}[POS]<CR>\centering<CR>\caption{}<CR>\label{}<CR><Esc>?POS<CR>cw
iabbrev <buffer> =v \texttt{DATA}<Esc>?DATA<CR>cw
iabbrev <buffer> =f \frac{DATA}{}<Esc>?DATA<CR>cw
iabbrev <buffer> =s \sqrt{DATA}<Esc>?DATA<CR>cw

function! RandomLabel()
python3 << EOF
import random, vim
str = str(random.getrandbits(64))
n = 6
label = "-".join([str[i:i+n] for i in range(0, len(str), n)])
vim.command("let @z = '%s'" % label)
EOF
endfunction

setlocal keywordprg=texdoc
" setlocal makeprg=latexmk\ -pdf\ -pvc\ %:r
setlocal formatprg=latexindent

setlocal complete+=i
setlocal formatlistpat=^\\\s*\\\\item\\s*

nmap <buffer> gs :VimtexCompile<CR>
nmap <buffer> <silent> gO :VimtexTocToggle<cr>
imap <C-h> <Esc>:call RandomLabel()<CR>a<C-R>z
nmap <C-h> <Esc>:call RandomLabel()<CR>a<C-R>z

nnoremap <silent> gr :call fzf#run({
                        \ 'source': 'bibtex-ls',
                        \ 'sink*': function('bibtex#bibtex_cite_sink'),
                        \ 'down': '10%',
                        \ 'options': '--ansi --multi --border top --prompt "Cite> "'})<CR>

