function Only()
  local cur_buf = vim.api.nvim_get_current_buf()
  for _, buf in ipairs(vim.api.nvim_list_bufs()) do
    if cur_buf ~= buf then
      pcall(vim.cmd, "bd " .. buf)
    end
  end
end

vim.cmd([[command -complete=dir -nargs=+ Grep silent grep <args> | redraw! | call misc#quickfix_toggle()]])
vim.cmd([[command! -nargs=? -range Align <line1>,<line2>call text#align_section('<args>')]])
vim.cmd([[command! Bibopen call bibtex#open_bibtex_key()]])
vim.cmd([[command! TagsCw call fzf#vim#tags(expand('<cword>'))]])
vim.cmd([[command! RgCw call misc#fzf_rg()]])
vim.cmd([[command! -range Gist call system('gist', getbufline('%', <line1>, <line2>))]])
vim.cmd(
  [[command! -range=% Htmlize call system('cat|pandoc -s -f markdown -o ~/tmp/out.html && xdg-open ~/tmp/out.html', getbufline('%', <line1>, <line2>))]]
)
vim.cmd([[command! Changelog execute "normal i<C-R>=strftime('%Y-%m-%d')<CR><ESC>$a chl <chl@aliquote.org> -"]])
vim.cmd([[noremap <silent><C-x> :lua Only()<cr>]])
