# Listing dir
alias ls="ls -F"
alias la="ls -FA"
if command -v exa >/dev/null 2>&1; then
  alias ll="exa --long --git"
fi
alias lsk="ls -lhSp"
alias lsr="ls -t| head -n 10"

# cd'ing stuff
alias ~='cd ~'
alias ..='cd ..'
alias ...=' cd ../../'
alias ....=' cd ../../../'
alias cd..='cd ../'

# More helpers
alias dud="du -sh ./* | sort -h"
alias dua='du -had 1 | sort -rh'
alias tree="tree -NC"
alias perms="stat -c '%A %a %n'"
alias cx="chmod +x"
if [ -n "$ZSH_VERSION" ]; then
  if command -v nvim >/dev/null 2>&1; then
    alias -g G="| rg"
  elif command -v vim >/dev/null 2>&1; then
    alias -g G="| rg"
  else
    alias -g G="| rg"
  fi
fi
if [ -n "$ZSH_VERSION" ]; then
  if command -v nvim >/dev/null 2>&1; then
    alias -g V="|& nvim -"
  elif command -v vim >/dev/null 2>&1; then
    alias -g V="|& vim -"
  else
    alias -g V="|& vi -"
  fi
fi
alias pbpaste="xclip -i -selection clipboard"

# Python stuff
alias venv="python3 -m venv"
alias venvup="source env/bin/activate"
alias pip-upgrade-all="pip3 freeze --user --local | grep -v '^\-e' | cut -d = -f 1  | xargs pip3 install -U --user"
alias jpy="jupyter console --simple-prompt"

# Default programs
alias R="R -q --no-save --no-restore"
alias bc="bc -lq"
alias open="xdg-open 2>/dev/null"
alias mutt=neomutt
alias news=newsboat
if command -v nvim >/dev/null 2>&1; then
  alias logbook="nvim ~/Documents/logs"
elif command -v vim >/dev/null 2>&1; then
  alias logbook="vim ~/Documents/logs"
else
  alias logbook="vi ~/Documents/logs"
fi
alias ec="emacsclient -n -t -a ''"
alias ew="env TERM=xterm-24bit emacs -nw"
alias vim=nvim
# alias vi="nvim -u NONE -N"

# Git
alias gc="git commit -m"
alias gd="git d"
alias ga="git add --all ."
alias gg="git status -s -b"

# tmux
alias mxa="tmux attach -t"
alias mxk="tmux kill-session -t"
alias mxl="tmux ls"
alias mxn="tmux new -s"

# Misc
alias optipng-max="optipng -f0-5 -zc6-9 -i0 -zm6-9"
alias nonascii="LC_CTYPE=C grep --color='auto' -n -P '[\x80-\xFF]'"
# alias bat="pygmentize -g"
alias notes='rg "TODO|NOTE|FIXME"'
alias p2x1="pdfnup --nup 2x1 --landscape --suffix '2x1' --batch "
alias pdfcat='gs -q -dNOPAUSE -dBATCH -sDEVICE=pdfwrite -sOutputFile=_merged.pdf'
alias dfh='df -h | grep -v tmpfs | grep -v snap'
alias orphans="ps -elf | head -1; ps -elf | awk '{if (\$5 == 1 && \$3 != \"root\") {print \$0}}' | head"
alias youtube-dl-mp3='youtube-dl -f bestaudio -x --audio-format mp3 --audio-quality 3'
alias week='date +%V'
alias localip="ipconfig getifaddr en0"
alias ips="ifconfig -a | grep -o 'inet6\? \(addr:\)\?\s\?\(\(\([0-9]\+\.\)\{3\}[0-9]\+\)\|[a-fA-F0-9:]\+\)' | awk '{ sub(/inet6? (addr:)? ?/, \"\"); print }'"
alias path='echo -e ${PATH//:/\\n}'
alias ical="khal calendar"
alias csi="rlwrap csi"
alias reload="exec ${SHELL} -l"
alias f="fdfind --type f --hidden --exclude .git | fzf-tmux -p 75,25 --reverse | xargs nvim"
